#include <minix/config.h>
#include "const.h"
#undef EXCEPTION
#if (CHIP == M68000)

!
! Only the registers that are considered scratch by the compiler used
! to compile the kernel are saved. Other registers are saved by the
! prolog generated by the kernel compiler.
!
#ifdef ALCYON
#define FREEREGS d0-d2/a0-a2
#endif
#ifdef ACK
#define FREEREGS d0-d2/a0-a1
#endif

#ifdef ACK
! section definition
	.sect	.text
	.sect	.rom
	.sect	.data
	.sect	.bss
#endif

!
! public labels
!
	.define	_lock
	.define	_unlock
	.define	_restore
	.define	_reboot
	.define	_sizes
#ifdef ACK
	.define	.trpim
	.define	.trppc
#endif
#if (MACHINE == X68000)
	.define	_mem_bytes
#endif

!
! external references
!
	.extern	_clock_handler
	.extern	_held_head
	.extern _k_reenter
	.extern	_proc_ptr
	.extern	_rdy_head
	.extern	_lock_pick_proc
	.extern	_main
	.extern	_none
	.extern	_rupt
	.extern	_trap
	.extern	_timint
#if (MACHINE == ATARI)
	.extern	_dmaint
	.extern	_aciaint
#endif
#if (MACHINE == X68000)
	.extern	_fdcint
#if 0
	.extern	_fdeint
#endif
	.extern	_hdcint
	.extern	_hdeint
	.extern	_sdcint
	.extern	_sdeint
	.extern _pcmcint
	.extern _pcmeint
	.extern	_kbdint
	.extern	_kbeint

	.extern	blink
#endif
	.extern	_siaint
	.extern	_piaint
	.extern	_iob
	.extern	_sys_call
!	.extern	_end
!	.extern	_edata

!
! offsets into a proc table entry
!
sava6	= 56
savsp	= 60
savpc	= 66
savsr	= 64
savtt	= 70
! lower byte of proc_t->p_trap
p_trap = 81

IOCS		= 15

B_LOCATE	= 35
B_CURON		= 0xAE
B_CUROFF	= 0xAF
B_PUTC		= 0x20

SCC_RA		= 0xe98005
SCC_DA		= 0xe98007

	.sect	.text
!
! Trap vectors
!
.data2	0,	0,	0,	start,	0x0200,	err,	0x0300,	err
.data2	0x0400,	trp,	0x0500,	trp,	0x0600,	trp,	0x0700,	trp
.data2	0x0800,	trp,	0x0900,	trc,	0x0A00,	trp,	0x0B00,	trp
.data2	0x0C00,	trp,	0x0D00,	trp,	0x0E00,	trp,	0x0F00,	trp
.data2	0x1000,	non,	0x1100,	non,	0x1200,	non,	0x1300,	non
.data2	0x1400,	non,	0x1500,	non,	0x1600,	non,	0,	conf
#if (MACHINE == ATARI)
.data2	0x1800,	int,	0x1900,	int,	0,	hbl,	0x1B00,	int
.data2	0,	vbl,	0x1D00,	int,	0x1E00,	int,	0x1F00,	int
#endif
#if (MACHINE == X68000)
.data2	0x1800,	bugint,	0x1900,	int,	0,	hbl,	0x1B00,	int
.data2	0,	vbl,	0x1D00,	int,	0x1E00,	int,	0x1F00,	nmi
#endif
.data2	0,	sys,	0x2100,	trp,	0x2200,	trp,	0x2300,	trp
.data2	0x2400,	trp,	0x2500,	trp,	0x2600,	trp,	0x2700,	trp
.data2	0x2800,	trp,	0x2900,	trp,	0x2A00,	trp,	0x2B00,	trp
.data2	0x2C00,	trp,	0x2D00,	trp,	0x2E00,	trp,	0x2F00,	trp
.data2	0x3000,	non,	0x3100,	non,	0x3200,	non,	0x3300,	non
.data2	0x3400,	non,	0x3500,	non,	0x3600,	non,	0x3700,	non
.data2	0x3800,	non,	0x3900,	non,	0x3A00,	non,	0x3B00,	non
.data2	0x3C00,	non,	0x3D00,	non,	0x3E00,	non,	0x3F00,	non
#if (MACHINE == ATARI)
.data2	0x0000,	pia,	0x0100,	iob,	0x0200,	iob,	0x0300,	iob
.data2	0x0300,	tim,	0x0200,	clk,	0,	acia,	0,	dma
.data2	0x0100,	tim,	0x0300,	sia,	0x0200,	sia,	0x0100,	sia
.data2	0x0000,	sia,	0x0000,	tim,	0x0600,	iob,	0x0700,	iob
#endif
#if (MACHINE == X68000)
.data2	0x0000,	non,	0x0100,	iob,	0x0200,	iob,	0x0300,	iob
.data2	0x0300,	clk,	0x0200,	tim,	0,	non,	0,	non
.data2	0x0100,	tim,	0x0300,	non,	0x0200,	non,	0x0100,	non
.data2	0x0000,	non,	0x0000,	tim,	0x0600,	iob,	0x0700,	iob
#endif
.data2	0x5000,	non,	0x5100,	non,	0x5200,	non,	0x5300,	non
.data2	0x5400,	non,	0x5500,	non,	0x5600,	non,	0x5700,	non
.data2	0x5800,	non,	0x5900,	non,	0x5A00,	non,	0x5B00,	non
.data2	0x5C00,	non,	0x5D00,	non,	0x5E00,	non,	0x5F00,	non
#if (MACHINE == X68000)
.data2	0x6000,	non,	0x6100,	non,	0x6200,	non,	0x0000,	pia
#else
.data2	0x6000,	non,	0x6100,	non,	0x6200,	non,	0x6300,	non
#endif
.data2	0x6400,	non,	0x6500,	non,	0x6600,	non,	0x6700,	non
.data2	0x6800,	non,	0x6900,	non,	0x6A00,	non,	0x6B00,	non
.data2	0x6C00,	non,	0x6D00,	non,	0x6E00,	non,	0x6F00,	non
.data2	0x7000,	non,	0x7100,	non,	0x7200,	hdi,	0x7300,	hde
.data2	0x7400,	sdi,	0x7500,	sde,	0x7600,	pcmi,	0x7700,	pcme
.data2	0x7800,	non,	0x7900,	non,	0x7A00,	non,	0x7B00,	non
.data2	0x7C00,	non,	0x7D00,	non,	0x7E00,	non,	0x7F00,	non
.data2	0x8000,	non,	0x8100,	non,	0x8200,	non,	0x8300,	non
.data2	0x8400,	non,	0x8500,	non,	0x8600,	non,	0x8700,	non
.data2	0x8800,	non,	0x8900,	non,	0x8A00,	non,	0x8B00,	non
.data2	0x8C00,	non,	0x8D00,	non,	0x8E00,	non,	0x8F00,	non
.data2	0x9000,	non,	0x9100,	non,	0x9200,	non,	0x9300,	non
.data2	0x9400,	non,	0x9500,	non,	0x9600,	non,	0x9700,	non
.data2	0x9800,	non,	0x9900,	non,	0x9A00,	non,	0x9B00,	non
.data2	0x9C00,	non,	0x9D00,	non,	0x9E00,	non,	0x9F00,	non
.data2	0xA000,	non,	0xA100,	non,	0xA200,	non,	0xA300,	non
.data2	0xA400,	non,	0xA500,	non,	0xA600,	non,	0xA700,	non
.data2	0xA800,	non,	0xA900,	non,	0xAA00,	non,	0xAB00,	non
.data2	0xAC00,	non,	0xAD00,	non,	0xAE00,	non,	0xAF00,	non
.data2	0xB000,	non,	0xB100,	non,	0xB200,	non,	0xB300,	non
.data2	0xB400,	non,	0xB500,	non,	0xB600,	non,	0xB700,	non
.data2	0xB800,	non,	0xB900,	non,	0xBA00,	non,	0xBB00,	non
.data2	0xBC00,	non,	0xBD00,	non,	0xBE00,	non,	0xBF00,	non
.data2	0xC000,	non,	0xC100,	non,	0xC200,	non,	0xC300,	non
.data2	0xC400,	non,	0xC500,	non,	0xC600,	non,	0xC700,	non
.data2	0xC800,	non,	0xC900,	non,	0xCA00,	non,	0xCB00,	non
.data2	0xCC00,	non,	0xCD00,	non,	0xCE00,	non,	0xCF00,	non
.data2	0xD000,	non,	0xD100,	non,	0xD200,	non,	0xD300,	non
.data2	0xD400,	non,	0xD500,	non,	0xD600,	non,	0xD700,	non
.data2	0xD800,	non,	0xD900,	non,	0xDA00,	non,	0xDB00,	non
.data2	0xDC00,	non,	0xDD00,	non,	0xDE00,	non,	0xDF00,	non
.data2	0xE000,	non,	0xE100,	non,	0xE200,	non,	0xE300,	non
.data2	0xE400,	non,	0xE500,	non,	0xE600,	non,	0xE700,	non
.data2	0xE800,	non,	0xE900,	non,	0xEA00,	non,	0xEB00,	non
.data2	0xEC00,	non,	0xED00,	non,	0xEE00,	non,	0xEF00,	non
.data2	0xF000,	non,	0xF100,	non,	0xF200,	non,	0xF300,	non
.data2	0xF400,	non,	0xF500,	non,	0xF600,	non,	0xF700,	non
.data2	0xF800,	non,	0xF900,	non,	0xFA00,	non,	0xFB00,	non
.data2	0xFC00,	non,	0xFD00,	non,	0xFE00,	non,	0xFF00,	non
!
! gap to allow ramdisk to survive
!
#if (MACHINE == X68000)
	.space	0x2400
#else
	.space	0x0200
#endif
!
! startup code, just after interrupt vectors
! clear bss (uninitialized data) section
! call _main and do process switch when it returns
!
start:
!	reset
#if (MACHINE == X68000)
! back ground color of console
	move.w	#0x0018,0xe82200	! background color
	move.w	#0xffff,0xe8221e	! character color
! memory size check
	move.l	#0x100000,a0
	move.l	8,a1
	move.l	#msz2,8
msz1:
	tst.b	(a0)
	add.l	#0x100000,a0
	bra	msz1
msz2:
	move.l	a1,8
	move.l	a0,_mem_bytes
! set some interrupt vectors
	move.b	#0x40,0xe88017	! mfp interrupt vector
	move.l	#clk,0x110
	move.l	#kbd,0x130
	move.l	#kbe,0x12c

	move.l	#sia,0x160
	move.l	#sia,0x168
	move.l	#sia,0x170
	move.l	#sia,0x178

	move.b	#0x60,0xe9c003	! hdc, fdc, fdd, prt interrupt vector
	move.l	#fdc,0x180
#endif
#ifdef EXCEPTION
	move.l	#except,0x180
	move.b	#0x60,0x180
#endif
	move.w	#0x2700,sr
	move.l  #k_stktop,sp	
!	move.l	#_end,d0
!	move.l	#_edata,a0
!	bra	L2
!L1:
!	move.w	#0,(a0)+
!L2:
!	cmp.l	d0,a0
!	bcs	L1
	jsr	_main
	bra	restart

!
! The vector handlers for synchronous traps. save full context.
!
err:
	add.l	#8,sp		! remove extra context
		! These info is useful for debug of user program.
		! It is a good idea to save them to somewhere and let user know.
trp:
	bsr	save
	jsr	_trap
	bra	restart
trc:
	btst	#5,(sp)		! tracing through trap?
	beq	trp		! No, do normal trace processing
	rte			! don't trace; execute system call
int:
	bsr	save
	jsr	_rupt
	bra	restart
non:
	bsr	save
	jsr	_none
	bra	restart
sys:
	bsr	save			! d0, d1 and a0 not modified
	move.l	a0,-(sp)		! m_ptr
	move.w	d1,-(sp)		! src_dest
	move.w	d0,-(sp)		! SEND/RECEIVE/BOTH
	move.l	_proc_ptr,a6		! needed to store return value
				! warning: _sys_call may change _proc_ptr
	jsr	_sys_call		! sys_call(func,src_dest,m_ptr)
	move.l  d0,(a6)
	add.l	#8,sp
	bra	restart
!
! The vector handlers for asynchronous traps. context saved only if necessary.
!
iob:
	movem.l	FREEREGS,-(sp)
	move.l	#_iob,a0
	bsr	async
tim:
	movem.l	FREEREGS,-(sp)
	move.l	#_timint,a0
	bsr	async
clk:
	jsr	blink
	sub.w	#1,clkcnt
	beq	cont
	rte
cont:
	move.w	#4,clkcnt
	movem.l	FREEREGS,-(sp)
	move.l	#_clock_handler,a0
	bsr	async
#if (MACHINE == ATARI)
dma:
	movem.l	FREEREGS,-(sp)
	move.l	#_dmaint,a0
	bsr	async
acia:
	movem.l	FREEREGS,-(sp)
	move.l	#_aciaint,a0
	bsr	async
#endif
sia:
	movem.l	FREEREGS,-(sp)
	move.l	#_siaint,a0
	bsr	async
pia:
	movem.l	FREEREGS,-(sp)
	move.l	#_piaint,a0
	bsr	async
#if (MACHINE == X68000)
fdc:
	movem.l	FREEREGS,-(sp)
	move.l	#_fdcint,a0
	bsr	async
#if 0
fde:
	movem.l	FREEREGS,-(sp)
	move.l	#_fdeint,a0
	bsr	async
#endif
hdi:
	movem.l	FREEREGS,-(sp)
	move.l	#_hdcint,a0
	bsr	async
hde:
	movem.l	FREEREGS,-(sp)
	move.l	#_hdeint,a0
	bsr	async
sdi:
	movem.l	FREEREGS,-(sp)
	move.l	#_sdcint,a0
	bsr	async
sde:
	movem.l	FREEREGS,-(sp)
	move.l	#_sdeint,a0
	bsr	async
pcmi:
	movem.l	FREEREGS,-(sp)
	move.l	#_pcmcint,a0
	bsr	async
pcme:
	movem.l	FREEREGS,-(sp)
	move.l	#_pcmeint,a0
	bsr	async
kbd:
	movem.l	FREEREGS,-(sp)
	move.l	#_kbdint,a0
	bsr	async
kbe:
	movem.l	FREEREGS,-(sp)
	move.l	#_kbeint,a0
	bsr	async
#endif
!
! The vector handlers that do not affect task switching
!
vbl:
	! currently still enabled, but ignored
	! possibly later something like
	!	movem.l	FREEREGS,-(sp)
	!	move.l	#_vbl,a0
	!	bsr	async
	rte
hbl:
	! must be avoided because it comes so frequent
	! execute spl2()
	or.w	#0x200,sr
	rte
	
#if (MACHINE == X68000)
bugint:
	! X68000 has a harware bug that causes $18 intrruption.
	rte
#endif	

!
! Asynchronous Trap
!
async:
	clr.w	d0			! extract traptype from saved pc
	move.b	(sp)+,d0		! sp incremented by 2
	move.w	d0,(sp)			! push traptype as argument
	add.b	#1,_k_reenter		! from -1 if not reentering
	jsr	(a0)			! call service routine
	tst.w	(sp)+			! pop traptype
	move.w	#0x2700,sr
	sub.b	#1,_k_reenter
	movem.l	(sp)+,FREEREGS
	btst	#5,(sp)			! previously in kernel mode?
				! (interrupted a task or another interrupt)
	bne	L3			! yes: branch and return from interrupt
	cmp.l	#0,_rdy_head+TASK_Q	! any task just readied?
	bne	L4			! yes: branch and do task switch
L3:
	rte
L4:
	bsr	save
	jsr	_lock_pick_proc
	bra	restart
!
! Perform task switch by save and restart
!
save:
	move.w	#0x2700,sr					! ?
	move.l	a6,-(sp)
	move.l	_proc_ptr,a6
	movem.l	d0-d7/a0-a5,(a6)
	move.l	(sp)+,sava6(a6)		! a6
	lea	10(sp),a1
	btst	#5,4(sp)		! test old S-bit
	bne	L5			! jump if S-bit on
	move.l	usp,a1
L5:	move.l	a1,savsp(a6)		! old sp: usp or ksp
	move.b	(sp),savtt(a6)		! trap type
 move.b (sp),p_trap(a6) ! proc_ptr->p_trap
	clr.b	(sp)			! cleanup
	move.l	(sp)+,a1		! return address
	move.w	(sp)+,savsr(a6)		! sr
	move.l	(sp)+,savpc(a6)		! pc
	add.b	#1,_k_reenter		! from -1 if not reentering
	jmp	(a1)

restart:
! Flush any held-up interrupts.
! This reenables interrupts, so the current interrupt handler may reenter.
! This doesn't matter, because the current handler is about to exit and no
! other handlers can reenter since flushing is only done when k_reenter == 0.

	move.w	#0x2700,sr
	tst.b	_k_reenter
	bne	over_call_unhold
	cmp.l	#0,_held_head
	beq	over_call_unhold
	jsr	_unhold
over_call_unhold:
	sub.b	#1,_k_reenter
	jsr	_checksp
	move.l	_proc_ptr,a6
	move.l	savsp(a6),a0		! old sp: usp or ksp
	btst	#5,savsr(a6)		! test old S-bit
	bne	L6			! jump if S-bit on
	move.l	a0,usp
	bra	L7
L6:	move.l	a0,sp
L7:	move.l	savpc(a6),-(sp)		! pc
	move.w	savsr(a6),-(sp)		! sr
	movem.l	(a6),d0-d7/a0-a6
	rte

_lock:
	move.w	sr,d0
	move.w	#0x2700,sr
	rts
_restore:
	move.w	4(sp),sr
	rts
_unlock:
#if (MACHINE == ATARI)
	move.w	#0x2200,sr		! spl2() to block HBL interrupt
#endif
#if (MACHINE == X68000)
	move.w	#0x2000,sr
#endif
	rts
_reboot:
#if (MACHINE == ATARI)
	move.l	4,a0
#endif
#if (MACHINE == X68000)
	move.l	0xff0004,a0
#endif
	jmp	(a0)

#if (MACHINE == X68000)

	.define	_printmsg
_printmsg:
	movem.l	d0/a1,-(sp)
	move.l	0xc(sp),a1
	move.l	#0x21,d0
	trap	#0x0f
	movem.l	(sp)+,d0/a1
	rts
#endif

	.sect	.data

_sizes:
	.data2	0x526F,0,0,0,0,0,0,0
conf:
	.extern	_proc
	.data4	_proc
	.extern	_keynorm
	.data4	_keynorm
	.extern	_keyshft
	.data4	_keyshft
	.extern	_keycaps
	.data4	_keycaps
#if (MACHINE == ATARI)
	.extern	_font8
	.data4	_font8
	.extern	_font16
	.data4	_font16
#endif
	.data4	0
#if (MACHINE == X68000)
	.data4	0
	.data4	0
#endif

clkcnt: .data2  4

	.space K_STACK_BYTES
k_stktop:
#if (MACHINE == X68000)
_mem_bytes:
	.data4	0
#endif

#ifdef ACK
	.sect	.text
	.extern	_write
	.extern	EXIT
_write:
EXIT:
	bra	EXIT

	.sect	.text
.trpim:	.data2	0
.trppc:	.data4	0
#endif /* ACK */

	.sect	.text
!	.extern	_v_dmp
nmi:
!	bsr	_v_dmp
	move.b	#0x0c,0xe8e007
	rte
#ifdef EXCEPTION
except:
	bsr	stkdump
here:	bra	here

stkdump:
	move.w	#0x2700,sr
	movem.l	d0/a0-a1,-(sp)
	pea	dbg_trap
	bsr	__dbg_str_print
	add.l 	#4,sp
	bsr	pushpc
	nop
pushpc:	bsr	__dbg_hex_print
	add.l 	#4,sp
	lea	16(sp),a0
	lea	256(a0),a1
stdmp0:	bsr	__dbg_crlf_print
stdmp1:	move.l	a0,-(sp)
	bsr	__dbg_hex_print
	add.l 	#4,sp
	move.w	#7,d0
	bsr	__dbg_sp_print
stdmp2:	bsr	__dbg_sp_print
	move.l	(a0)+,-(sp)
	bsr	__dbg_hex_print
	add.l 	#4,sp
	cmp.l	a1,a0
	bcc	stdmp3
	dbra	d0,stdmp2
	bra	stdmp0
stdmp3:	bsr	__dbg_crlf_print
#if 0
	move.l	#0,a0
veck1:	cmp.w	#except,2(a0)
	beq	veck2
	pea	dbg_vec
	bsr	__dbg_str_print
	add.l 	#4,sp
	move.l	a0,d0
	lsr.l	#2,d0
	move.l	d0,-(sp)
	bsr	__dbg_hex_print
	add.l 	#4,sp
	bsr	__dbg_sp_print
	move.l	(a0),-(sp)
	bsr	__dbg_hex_print
	add.l 	#4,sp
	bsr	__dbg_sp_print
	bsr	__dbg_sp_print
	bsr	__dbg_sp_print
veck2:	lea	4(a0),a0
	cmp	#0x400,a0
	bne	veck1
	bsr	__dbg_crlf_print
#endif
	movem.l	(sp)+,d0/a0-a1
	rts
#endif
	.define __dbg_str_print
__dbg_str_print:
	move.w	sr,-(sp)
	move.w	#0x2700,sr
	movem.l d0/a1,-(sp)
	move.l  0xe(sp),a1
	move.l  #0x21,d0
	trap	#0x0f
	movem.l (sp)+,d0/a1
	move.w	(sp)+,sr
	rts
#if 1
	.define __dbg_hex_print
__dbg_hex_print:
	move.w	sr,-(sp)
	move.w	#0x2700,sr
	movem.l	d0-d2/a0-a1,-(sp)
	move.l	0x1a(sp),d0
	move.l	#7,d1
	lea	dbg_val+8,a1
L99:	move.b	d0,d2
	and.l	#15,d2
	lea	dbg_hex,a0
	add	d2,a0
	move.b	(a0),-(a1)
	lsr.l	#4,d0
	dbra	d1,L99
	lea	dbg_val,a1
	move.l	#0x21,d0
	trap	#0x0f
	movem.l (sp)+,d0-d2/a0-a1
	move.w	(sp)+,sr
	rts
__dbg_sp_print:
	pea	dbg_sp
	bsr	__dbg_str_print
	add.l 	#4,sp
	rts
__dbg_crlf_print:
	pea	dbg_crlf
	bsr	__dbg_str_print
	add.l 	#4,sp
	rts

	.sect	.data
dbg_hex:
	.ascii	"0123456789abcdef"
dbg_val:
	.data1	0,0,0,0,0,0,0,0,0
dbg_vec:
	.ascii	"vec "
	.data1	0
dbg_trap:
	.ascii	"exception state  "
	.data1	0
dbg_sp:
	.ascii	" "
	.data1	0
dbg_crlf:
	.data1	0x0d,0x0a,0
dbg_align:
	.data1	0

#endif
	.sect	.data
dbg_msg:
	.ascii	"restart"
	.data1	0
#endif
