#if (MACHINE == X68000)
/*
 * This file contains a fake driver for primary hard disk interface
 * on the Sharp X68000.
 *
 * The file contains one entry point:
 *
 *	winchester_task: main entry when system is brought up
 *
 */

#include "kernel.h"
#include <minix/callnr.h>
#include <minix/com.h>
#include "proc.h"

#define TRACE(x)	/* x */
#define DEBUG(x)	x

PRIVATE message mess;		/* message buffer for in and out */

/*===========================================================================*
 *				winchester_task				     *
 *===========================================================================*/
PUBLIC void winchester_task()
{
  register int	r, caller, procno;

  /*
   * The main loop of the disk task.
   * It waits for a message, carries it out, and sends a reply.
   */
  while (TRUE) {
	receive(ANY, &mess);
	if (mess.m_source < 0)
		panic("disk task got message from ", mess.m_source);
	TRACE(printf("hd: received %d from %d\n",mess.m_type,mess.m_source));
	caller = mess.m_source;
	procno = mess.PROC_NR;

	/* Finally, prepare and send the reply message. */
	mess.m_type = TASK_REPLY;	
	mess.REP_PROC_NR = procno;
	mess.REP_STATUS = EIO;	/* always return error code */
	send(caller, &mess);	/* send reply to caller */
  }
}

/*===========================================================================*
 *				hdcint					     *
 *===========================================================================*/

PUBLIC void hdcint()
{
}

PUBLIC void hdeint()
{
}
#endif 
