#ifdef boot_hd
#define	BOOT
#define	type_hd
#endif
#ifdef boot_sd
#define	BOOT
#define	type_sd
#endif
#ifdef boot_husd
#define	BOOT
#define	type_husd
#define type_sd
#endif
#ifdef boot_fd
#define	BOOT
#define	type_fd
#endif

#ifndef type_fd
#ifndef type_sd
#ifndef type_hd
#define	type_fd
#endif
#endif
#endif

#ifdef ACK
	.sect	.text
	.sect	.rom
	.sect	.data
	.sect	.bss
#endif

	.sect	.text
start:
#ifdef BOOT
	bra	boot		! 000: jump to loader
#else
	rts			! 000: do not boot
#endif
	.ascii	"MINIX "	! 002: 6 byte identification
block:
	.data4	0		! 008: boot block number

#define SKIP_VEC

sizes	= 480
magic	= 502
nsect	= 504
fsckd	= 506
zero	= 508
fsckt	= 510

ldaddr	= 0x100000

boot:
	pea	reading(pc)
	bsr	print_msg
	add.l 	#4,sp
	move.l	#0x8e,d0
	trap	#15
#ifdef type_sd
	move.l	d0,a6
	move.l	(a6),a6
	move.l	-12(a6),a6
#ifdef type_husd
	move.l	d7,d1
#endif
#else
	move.l	d0,d1
	lsl.l	#8,d1
#ifdef type_fd
	move.b	#0x70,d1
#endif
#endif
	clr.w	d6		! start with block 0
	lea	start+sizes(pc),a4 ! address of sector table
	add.w	#1,(a4)		! count boot block
	move.l	#ldaddr,a3	! load address in memory
read:
	clr.l	d5		! load sectors from disc
	move.w	(a4)+,d5
	beq	4f		! count of 0 means loading finished
	bsr	rwabs
	bne	fail
	add.w	d5,d6
	asl.l	#8,d5
	asl.l	#1,d5
	add.l	d5,a3

	clr.l	d0		! create bss area of part
	move.w	(a4)+,d0
	asl.l	#8,d0
	beq	read
3:
	clr.w	(a3)+
	sub.l	#1,d0
	bne	3b
	bra	read
4:
	lea	copy(pc),a0
	lea	start(pc),a1
	sub.l	a1,a0
	add.l	#ldaddr,a0
	jmp	(a0)		! jump to copy routine at ldaddr

copy:
	move.w	#0x2700,sr
	move.l	#8,a0
	move.l	#ldaddr+0x208,a1! start address of minix
#ifdef SKIP_VEC
	move.l	#0xa8,d0	! vector 00 => 29
1:	move.l	(a1)+,(a0)+
	cmp.l	a0,d0
	bne	1b
	move.l	#0x1b0,a0	! vector 6c => ff
	move.l	#ldaddr+0x3b0,a1
#endif
	move.l	#0x400,d0
2:	move.l	(a1)+,(a0)+
	cmp.l	a0,d0
	bne	2b
	add.l	#0x2400,a0	! skip iocs variables
	add.l	#0x2400,a1
	clr.l	d0
	move.w	start+nsect(pc),d0
	asl.l	#8,d0		! multiply
	asl.l	#1,d0		! with 512
3:	move.l	(a1)+,(a0)+
	cmp.l	a0,d0
	bne	3b
#ifdef type_fd
	bsr	eject
#endif
	move.l	ldaddr+0x204,a0
	jmp	(a0)		! minix boot address

fail:
	pea	error(pc)
	bsr	print_msg
	add.l 	#4,sp
	move.l	d0,-(sp)
	bsr	print_hex
	add.l 	#4,sp
loop:	bra	loop		! cannot load MINIX;

rwabs:
	movem.l		d1-d7/a0-a6,-(a7)
#ifdef type_sd
#ifdef type_husd
	move.l	a3,a2		! load addr a3 to a2
	move.l	d5,d3		! load size d5 to d3
	clr.l	d2
	add.w	d6,d2
	add.l	block(pc),d2	! address of boot block
	move.l	#0x200,d4
	move.l	#0xb,d0
#else
	move.l	a3,a1		! load addr a3 to a1
	move.l	d5,d3		! load size d5 to d3
	clr.l	d2
	add.w	d6,d2
	add.l	block(pc),d2	! address of boot block
	move.l	#1,d5
	move.l	#0x21,d1
#endif
	jsr	(a6)
#else
	move.l	a3,a1		! load addr a3 to a1
	move.l	d5,d3		! load size d5 to d3
	asl.l	#8,d3		! multiply
	asl.l	#1,d3		! with 512
#ifdef type_hd
	clr.l	d2
	add.w	d6,d2
	lsl.l	#1,d2
	add.l	block(pc),d2	! address of boot block
#endif
#ifdef type_fd
	move.l	#0x02000001,d2	! make location
	clr.l	d0		!  02 CC HH SS
	move.w	d6,d0
	divu	#15,d0
	lsr.w	#1,d0
	bcc	9f
	add.w	#0x100,d2
9:	swap	d2
	move.b	d0,d2
	swap	d2
	swap	d0
	add.b	d0,d2
#endif
	move.w	#0x46,d0
	trap	#15
#endif
	pea	dot(pc)
	bsr	print_msg
	add.l 	#4,sp
	movem.l	(a7)+,d1-d7/a0-a6
#ifdef type_fd
	clr.l		d0
!	and.l	0xc0000000,d0
#endif
#ifdef type_hd
	and.l	0x80000000,d0
#endif
#ifdef type_sd
	tst.l	d0
#endif
	rts

#ifdef type_fd
eject:
	movem.l	d0-d1,-(sp)
	move.l	#0x4f,d0
	move.l	#0x9000,d1
	trap	#15
	movem.l	(sp)+,d0-d1
	rts
#endif

print_msg:
	movem.l d0/a1,-(sp)
	move.l  0xc(sp),a1
	move.l  #0x21,d0
	trap	#0x0f
	movem.l (sp)+,d0/a1
	rts

print_hex:
	move.w	sr,-(sp)
	move.w	#0x2700,sr
	movem.l	d0-d2/a0-a1,-(sp)
	pea	dot(pc)
	bsr	print_msg
	add.l 	#4,sp
	move.l	0x1a(sp),d0
	move.l	#7,d1
	lea	dbg_val+8(pc),a1
L99:	move.b	d0,d2
	and.l	#15,d2
	lea	dbg_hex(pc),a0
	add	d2,a0
	move.b	(a0),-(a1)
	lsr.l	#4,d0
	dbra	d1,L99
	lea	dbg_val(pc),a1
	move.l	#0x21,d0
	trap	#0x0f
	movem.l (sp)+,d0-d2/a0-a1
	move.w	(sp)+,sr
	rts

reading:
	.data1	0x1b
	.ascii	"[2JReading Boot Disk."
	.data1	0
error:
	.data1	0xd,0xa
	.ascii	"Read Error."
	.data1	0
dot:
	.ascii	"."
	.data1	0
dbg_hex:
	.ascii	"0123456789abcdef"
dbg_val:
	.data1	0,0,0,0,0,0,0,0,0
